function output = bstrap(pm_init,y,x,z,ymax,xmax,zmax,nr)

% We use the bootstrap method to compute standard erros of 
%        parameters of alpha and rho.
% nr : the number of replication

unif = 50*rand(nr,50);

talpha = []; trho = [];

    % Parameter Restrictions
    % 0.01 <= alpha <= 0.99, 0 <= rho <= 5
    
    A = [-1 0; 1 0; 0 -1; 0 1];
    b = [-0.01;0.99;0;5];
    
    options = optimset('Algorithm','interior-point','Display','off','MaxFunEvals',1.0E+5);


for i = 1:nr    
    
    i
    
    rsam = unif(i,:);    
    ry = []; rx = []; rz = []; rymax = []; rxmax = []; rzmax = [];
    
    % bootstrap sampling without replacement
    
    for j = 1:50        
        for k = 1:50
            if (((k-1) <= rsam(j))&& (rsam(j)<k)) 
                
                ry = [ry; y(k)]; rx = [rx; x(k)]; rz = [rz; z(k)];
                rymax = [rymax; ymax(k)]; rxmax = [rxmax; xmax(k)];
                rzmax = [rzmax; zmax(k)];
                
            end            
        end 
    end
    
    pm01 = pm_init;
    
    [pm1,tssr1] = fmincon(@ssr,pm01,A,b,[],[],[],[],[],options,ry,rx,rz,rymax,rxmax,rzmax);
        
    pm02 = [1/2;0.1];
    
    [pm2,tssr2] = fmincon(@ssr,pm02,A,b,[],[],[],[],[],options,ry,rx,rz,rymax,rxmax,rzmax);
    
    pm03 = [0.4;0.05];
    
    [pm3,tssr3] = fmincon(@ssr,pm03,A,b,[],[],[],[],[],options,ry,rx,rz,rymax,rxmax,rzmax);

    pm04 = [0.6;0.05];
    
    [pm4,tssr4] = fmincon(@ssr,pm04,A,b,[],[],[],[],[],options,ry,rx,rz,rymax,rxmax,rzmax);
    
    tssrmin = min([tssr1 tssr2 tssr3 tssr4]);
    
    if (tssr1 == tssrmin)
        
        pm = pm1; 
    
    elseif (tssr2 == tssrmin)
        
        pm = pm2; 
        
    elseif (tssr3 == tssrmin)
        
        pm = pm3; 
                
    else 
        
        pm = pm4; 

    end

    alpha = pm(1); rho = pm(2);
    
    talpha = [talpha;alpha]; trho = [trho;rho]; 
    
end

tall = [talpha, trho];

output = tall;
end



