function output = ssr(pm,y,x,z,ymax,xmax,zmax)

% Compute the sum of squared residuals given the parameter values
% Alpha: ambiguity aversion, rho: risk aversion
% Their restrictions are 0 < alpha <= 1, 0 <= rho <= 5.

alpha = pm(1); rho = pm(2);

% Transforming the parameters into the generalized kinked specification

beta = (2/3)*alpha - (1/3);

n = length(y); out = 0;

for i = 1:n
    
    p1 = 1/xmax(i); p2 = 1/ymax(i); p3 = 1/zmax(i);

    od = demand(p1,p2,p3,0,beta,rho);

    if (isreal(od) == 1)
        
            out = out + (x(i) - od(1))^2 + (y(i) - od(2))^2 + (z(i)- od(3))^2;
           
    else
        
        isreal(od)
        od
        [alpha, rho]
        pause
    end

    
end

output = out;

end