clc
clear

load ESTM_RDU_Final_Dec2012.mat

dt = ESTM_RDU_Final_Dec2012;

[n,m] = size(dt);

wald_all = [];


for i = 1:n
    
    id = dt(i,1);
    
    hyp = [dt(i,3); dt(i,4)];
    
    cov = [dt(i,6) dt(i,8);dt(i,8) dt(i,7)];

    wald = hyp'*inv(cov)*hyp;
    
    pvalue_wald = 1 - chi2cdf(wald,2);
    
    t_beta = dt(i,3)/sqrt(dt(i,6));
    
    % one-sided test
    
    pvalue_beta = (1 - normcdf(abs(t_beta),0,1));
    
    t_gamma = dt(i,4)/sqrt(dt(i,7));
    
    % one-sided test
    
    pvalue_gamma = (1 - normcdf(abs(t_gamma),0,1));    
    
    wald_all = [wald_all;id wald pvalue_wald t_beta pvalue_beta t_gamma pvalue_gamma];
    
    
end


