function output = bstrap(pm0,y,x,z,ymax,xmax,zmax,nr)

% We use the bootstrap method to compute standard erros of 
%        parameters of gamma, beta and rho
%    (loss aversion) = gamma, (ambiguity aversion) = beta  in this file.
% nr : the number of replication

unif = 50*rand(nr,50);

tgamma = []; trho = []; tbeta = [];

    % Parameter Restrictions; eps = 0.01
    % -1/3 + eps <= gamma <= 1/3 - eps, -1/3 + eps <= beta <= 1/3 - eps, 0 <= rho <= 5
    % -1/3 + eps <= gamma + beta <= 1/3 - eps
    
    eps = 0.01;
    
    A = [-1 0 0; 1 0 0; 0 -1 0; 0 1 0; -1 -1 0; 1 1 0; 0 0 -1; 0 0 1];
    b = [1/3 - eps; 1/3 - eps; 1/3 - eps; 1/3 - eps; 1/3 - eps; 1/3 - eps; 0; 5];
    
    LB = [ -1/3 + eps; -1/3 + eps; 0]; UB = [ 1/3 - eps; 1/3 - eps; 5];    
    
    options = optimset('Algorithm','interior-point','Display','off','MaxFunEvals',1.0E+5);


for i = 1:nr    
    
    i
    
    rsam = unif(i,:);    
    ry = []; rx = []; rz = []; rymax = []; rxmax = []; rzmax = [];
    
    for j = 1:50        
        for k = 1:50
            if (((k-1) <= rsam(j))&& (rsam(j)<k)) 
                
                ry = [ry; y(k)]; rx = [rx; x(k)]; rz = [rz; z(k)];
                rymax = [rymax; ymax(k)]; rxmax = [rxmax; xmax(k)];
                rzmax = [rzmax; zmax(k)];
                
            end            
        end 
    end
        
    pm01 = pm0;
    
    [pm1,tssr1] = fmincon(@ssr1,pm01,A,b,[],[],LB,UB,[],options,ry,rx,rz,rymax,rxmax,rzmax);
        
    pm02 = [0.1;0;0.05];
    
    [pm2,tssr2] = fmincon(@ssr1,pm02,A,b,[],[],LB,UB,[],options,ry,rx,rz,rymax,rxmax,rzmax);
    
    pm03 = [0;0.1;0.05];
    
    [pm3,tssr3] = fmincon(@ssr1,pm03,A,b,[],[],LB,UB,[],options,ry,rx,rz,rymax,rxmax,rzmax);
    
    pm04 = [-0.1;0;0.05];
    
    [pm4,tssr4] = fmincon(@ssr1,pm04,A,b,[],[],LB,UB,[],options,ry,rx,rz,rymax,rxmax,rzmax);
    
    pm05 = [0;-0.1;0.05];
    
    [pm5,tssr5] = fmincon(@ssr1,pm05,A,b,[],[],LB,UB,[],options,ry,rx,rz,rymax,rxmax,rzmax);
    
    pm06 = [0;0;0.1];
    
    [pm6,tssr6] = fmincon(@ssr1,pm06,A,b,[],[],LB,UB,[],options,ry,rx,rz,rymax,rxmax,rzmax);
     
    tssrmin = min([tssr1 tssr2 tssr3 tssr4 tssr5 tssr6]);
    
    if (tssr1 <= tssrmin)
        
        pm = pm1; 
    
    elseif (tssr2 <= tssrmin)
        
        pm = pm2; 
        
    elseif (tssr3 <= tssrmin)
        
        pm = pm3; 
        
    elseif (tssr4 <= tssrmin)
        
        pm = pm4; 
        
    elseif (tssr5 <= tssrmin)
        
        pm = pm5; 
               
    else
        
        pm = pm6; 
        
    end
        
    beta = pm(1); gamma = pm(2); rho = pm(3);
        
    tgamma = [tgamma;gamma]; trho = [trho;rho]; tbeta = [tbeta;beta];
    
end

tall = [tbeta,tgamma,trho];

output = tall;

end



