function output = negU(s,alpha0,rho,p1,p2,p3)

r1 = 1/(1 + exp(s(1)) + exp(s(2))); r2 = 1/(1 + exp(-s(1)) + exp(s(2)-s(1)));
r3 = max([1-r1-r2, 0]);

x1 = (1/p1)*r1; x2 = (1/p2)*r2; 

x3 = (1/p3)*r3;

sU1 = CARA(x1,rho); sU2 = CARA(x2,rho); sU3 = CARA(x3,rho);

if (alpha0 < 1e-06)
    
    output = -((1/3)*sU1 + (1/3)*sU2 + (1/3)*sU3);

else
    
    if ((abs(sU1-sU3) < 1e-40)||(x1 == x3))
    
        output = -(-1/alpha0)*exp(-(alpha0/3)*sU2)*(2/3)*exp((-2*alpha0/3)*sU1);
    
    else

        output = -(-1/alpha0)*exp(-(alpha0/3)*sU2)*((exp((-2*alpha0/3)*sU1) - exp((-2*alpha0/3)*sU3))/(-alpha0*(sU1 - sU3)));

    end

end

